using System;
using System.Diagnostics;
using System.Windows.Forms;
using System.Text;
using System.IO;
using System.Runtime.InteropServices;

namespace PropLoader
{
	public partial class FormMain
	{

	#region  Declare DLL Functions / Variables

		[DllImport("Propellent.dll", CharSet=CharSet.Ansi, CallingConvention=CallingConvention.Cdecl)]
		private extern static void InitPropellent(IntPtr WinHandel, bool StorePrefs, IntPtr PChar);

		[DllImport("Propellent.dll", CharSet=CharSet.Ansi, CallingConvention=CallingConvention.Cdecl)]
		private extern static void FinalizePropellent();

		[DllImport("Propellent.dll", CharSet=CharSet.Ansi, CallingConvention=CallingConvention.Cdecl)]
		private extern static void DownloadToPropeller(StringBuilder Filename, byte Command);

		private bool mPropDllLoaded = false;
		private string mCurrentFile = "";

	#endregion

	#region  Form
        
		private void Form1_Load(object sender, System.EventArgs e)
		{
			try
			{
				InitPropellent(this.Handle, false, IntPtr.Zero);
			}
			catch (System.Exception ex)
			{
				MessageBox.Show("Propellent.Dll was not Found", string.Empty, MessageBoxButtons.OK, MessageBoxIcon.Error);
				System.Environment.Exit(1);
			}
			mPropDllLoaded = true;
		}
               
		private void Form1_FormClosing(object sender, System.Windows.Forms.FormClosingEventArgs e)
		{
			try
			{
				if (mPropDllLoaded == true)
				{
					FinalizePropellent();
				}
			}
			catch (System.Exception ex)
			{
			}
 		}

	#endregion

	#region  Buttons

		private void btnEEPROM_Click(object sender, System.EventArgs e)
		{
			Download(mCurrentFile, 3);
		}

		private void btnRAM_Click(object sender, System.EventArgs e)
		{
			Download(mCurrentFile, 1);
		}

		private void btnLoad_Click(object sender, System.EventArgs e)
		{

			try
			{
				OpenFileDialog myOpenDialog = new OpenFileDialog();
				myOpenDialog.DefaultExt = ".binary";
				myOpenDialog.Filter = "BINARY File(*.binary)|*.binary|EEPROM File (*.eeprom)|*.eeprom|All files (*.*)|*.*";
				myOpenDialog.Title = "Load File...";
				if (myOpenDialog.ShowDialog() == System.Windows.Forms.DialogResult.OK)
				{
					if (File.Exists(myOpenDialog.FileName))
					{
						mCurrentFile = myOpenDialog.FileName;
						Label1.Text = "Current File: " + Path.GetFileName(myOpenDialog.FileName);
						btnRAM.Enabled = false;
						btnEEPROM.Enabled = false;

						switch (Path.GetExtension(myOpenDialog.FileName).ToUpper())
						{
							case ".BINARY":
								btnRAM.Enabled = true;
								break;
							case ".EEPROM":
								btnEEPROM.Enabled = true;
								btnRAM.Enabled = true;
								break;
						}
					}
				}
				myOpenDialog.Dispose();
			}
			catch (System.Exception ex)
			{

			}
		}

	#endregion

	#region  Subs

		private void Download(string FileName, byte Mode)
		{
			try
			{
				if (mPropDllLoaded == true)
				{
					DownloadToPropeller(new StringBuilder(FileName), Mode);
				}
			}
			catch (System.Exception ex)
			{

			}
		}

	#endregion

	}
}